package test;

import java.util.Properties;

import java.util.Vector;

import javax.jws.WebMethod;
import javax.jws.WebService;

import javax.naming.Context;
import javax.naming.Name;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.Attribute;
import javax.naming.directory.Attributes;
import javax.naming.directory.BasicAttribute;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;

import javax.xml.bind.annotation.XmlSeeAlso;

import test.bean.LdapUser;

@WebService
@XmlSeeAlso( { LdapUser.class })
public class LDAPUtils implements LDAPUtilInt{
    
    
    final static String ldapServerName = "hsimonne-fr";
    final static String ldapServerPort = "389";
    final static String rootdn = "cn=Directory Manager";
    final static String rootpass = "ora123";
    final static String rootContext = "dc=example,dc=com";
    
    public LDAPUtils() {
       
    }
    
    
    public  Vector<LdapUser> retrieveUser(String cn){
        
        Properties env = new Properties();
                     
        env.put( Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory" );
        env.put( Context.PROVIDER_URL, "ldap://" + ldapServerName + ":"+ldapServerPort+"/" + rootContext );
        env.put( Context.SECURITY_PRINCIPAL, rootdn );
        env.put( Context.SECURITY_CREDENTIALS, rootpass );
        
        DirContext ctx;
        Vector<LdapUser> entries = new Vector<LdapUser>();
        try {
         
         
            String base = "ou=People";
            
            SearchControls sc = new SearchControls();
           // String[] attributeFilter = { "cn", "mail" };
            //sc.setReturningAttributes(attributeFilter);
            sc.setSearchScope(SearchControls.SUBTREE_SCOPE);   ctx = new InitialDirContext(env);
            
            String filter = "(&(objectclass=*)(cn="+cn+"))";
            NamingEnumeration results = ctx.search(base, filter, sc);
            
           
            
            while (results.hasMore()) {
                
                SearchResult sr = (SearchResult) results.next();
                Attributes attrs = sr.getAttributes();
                
                LdapUser currentEntry = new LdapUser();
                currentEntry.setDescription(""+attrs.get("description"));
                currentEntry.setEmail(""+attrs.get("mail"));
                currentEntry.setFirstname(""+attrs.get("givenName"));
                currentEntry.setLastname(""+attrs.get("sn"));
                currentEntry.setMobile(""+attrs.get("mobile"));
                currentEntry.setUid(""+attrs.get("cn"));
                
                entries.add(currentEntry);
                
                System.out.println(currentEntry.getEmail()+" "+currentEntry.getFirstname()+" "+currentEntry.getLastname()+" "+currentEntry.getUid() );
            }
            
            ctx.close();
                        
        } catch (NamingException e) {
            e.printStackTrace();
        }
        return entries;
        
    }


  public  String retrieveEmail(String cn){
      
      Properties env = new Properties();
                   
      env.put( Context.INITIAL_CONTEXT_FACTORY,"com.sun.jndi.ldap.LdapCtxFactory" );
      env.put( Context.PROVIDER_URL, "ldap://" + ldapServerName + ":"+ldapServerPort+"/" + rootContext );
      env.put( Context.SECURITY_PRINCIPAL, rootdn );
      env.put( Context.SECURITY_CREDENTIALS, rootpass );
      String sEmail="";
      
      DirContext ctx;
      Vector<LdapUser> entries = new Vector<LdapUser>();
      try {
       
       
          String base = "ou=People";
          
          SearchControls sc = new SearchControls();
         // String[] attributeFilter = { "cn", "mail" };
          //sc.setReturningAttributes(attributeFilter);
          sc.setSearchScope(SearchControls.SUBTREE_SCOPE);   ctx = new InitialDirContext(env);
          
          String filter = "(&(objectclass=*)(cn="+cn+"))";
          NamingEnumeration results = ctx.search(base, filter, sc);
          
         
          
          while (results.hasMore()) {
              
              SearchResult sr = (SearchResult) results.next();
              Attributes attrs = sr.getAttributes();
              
              LdapUser currentEntry = new LdapUser();
              currentEntry.setDescription(""+attrs.get("description"));
              currentEntry.setEmail(""+attrs.get("mail"));
              currentEntry.setFirstname(""+attrs.get("givenName"));
              currentEntry.setLastname(""+attrs.get("sn"));
              currentEntry.setMobile(""+attrs.get("mobile"));
              currentEntry.setUid(""+attrs.get("cn"));
              
              entries.add(currentEntry);
              
              sEmail = currentEntry.getEmail();
          }
          
          ctx.close();
                      
      } catch (NamingException e) {
          e.printStackTrace();
      }
      return sEmail;
      
  }

    @WebMethod(exclude = true)
    public static void main(String[] args) {
        
        LDAPUtils utils = new LDAPUtils();
        //utils.retrieveUser("test");
        System.out.println("Email=" + utils.retrieveEmail("test"));
    }
    
}
